#include "matriz.h"

// leitura da matriz
void leMatriz(Matriz *A) {
	/* COMPLETE AQUI COM SEU CODIGO */
	scanf("%d %d", &A->m, &A->n);
	for (int i=0; i<A->m; i++) {
		for (int j=0; j<A->n; j++) {
			scanf("%d", &A->mat[i][j]);
		}
	}
	return;
	/* COMPLETE AQUI COM SEU CODIGO */
}

// imprime uma matriz
void imprimeMatriz(Matriz A) {
	/* COMPLETE AQUI COM SEU CODIGO */
	if (A.m == 0 || A.n == 0) printf("Matriz invalida\n");
	for (int i=0; i<A.m; i++) {
		for (int j=0; j<A.n; j++) {
			printf("%d ", A.mat[i][j]);
		}
		printf("\n");
	}
	return;
	/* COMPLETE AQUI COM SEU CODIGO */
}

// calcula a multiplicacao de uma matriz por uma constante
Matriz MultiplicacaoConstante(Matriz A, int c) {
	/* COMPLETE AQUI COM SEU CODIGO */
	Matriz C;
	C.n = A.n;
	C.m = A.m;
	for (int i=0; i<A.m; i++) {
		for (int j=0; j<A.n; j++) {
			C.mat[i][j] = A.mat[i][j]*c;
		}
	}
	return C;
	/* COMPLETE AQUI COM SEU CODIGO */
}

// calcula a adicao de duas matrizes
Matriz AdicaoMatriz(Matriz A, Matriz B) {
	/* COMPLETE AQUI COM SEU CODIGO */
	Matriz C;
	if (A.m != B.m || A.n != B.n) 
		C.n = C.m = 0;
	else {
		C.n = A.n;
		C.m = A.m;
		for (int i=0; i<A.m; i++) {
			for (int j=0; j<A.n; j++) {
				C.mat[i][j] = A.mat[i][j] + B.mat[i][j];
			}
		}
	}
	return C;
	/* COMPLETE AQUI COM SEU CODIGO */
}

// calcula a subtracao de duas matrizes
Matriz SubtracaoMatriz(Matriz A, Matriz B) {
	/* COMPLETE AQUI COM SEU CODIGO */
	Matriz C;
	if (A.m != B.m || A.n != B.n) 
		C.n = C.m = 0;
	else {
		C.n = A.n;
		C.m = A.m;
		for (int i=0; i<A.m; i++) {
			for (int j=0; j<A.n; j++) {
				C.mat[i][j] = A.mat[i][j] - B.mat[i][j];
			}
		}
	}
	return C;
	/* COMPLETE AQUI COM SEU CODIGO */
}

// calcula a multiplicacao de duas matrizes
Matriz MultiplicacaoMatriz(Matriz A, Matriz B) {
	/* COMPLETE AQUI COM SEU CODIGO */
	Matriz C;
	if (A.n != B.m) 
		C.n = C.m = 0;
	else {
		C.n = B.n;
		C.m = A.m;
		for (int i=0; i<A.m; i++) {
			for (int j=0; j<B.n; j++) {
				C.mat[i][j] = 0;
				for (int k=0; k<A.n; k++)
					C.mat[i][j] += A.mat[i][k]*B.mat[k][j];
			}
		}
	}
	return C;
	/* COMPLETE AQUI COM SEU CODIGO */
}

// calcula a transposta de uma matriz
Matriz MatrizTransposta(Matriz A) {
	/* COMPLETE AQUI COM SEU CODIGO */
	Matriz C;
	C.n = A.m;
	C.m = A.n;
	for (int i=0; i<A.m; i++) {
		for (int j=0; j<A.n; j++) {
			C.mat[j][i] = A.mat[i][j];
		}
	}
	return C;
	/* COMPLETE AQUI COM SEU CODIGO */
}

// checa se uma matriz é simétrica
int MatrizSimetrica(Matriz A) {
	/* COMPLETE AQUI COM SEU CODIGO */
	Matriz T = MatrizTransposta(A);
	if (A.m != T.m && A.n != T.n) return 0;
	for (int i=0; i<A.m; i++) {
		for (int j=0; j<A.n; j++) {
			if (A.mat[i][j] != T.mat[i][j]) return 0;
		}
	}
	return 1;
	/* COMPLETE AQUI COM SEU CODIGO */
}

// checa se uma matriz é quadrada
int MatrizQuadrada(Matriz A) {
	/* COMPLETE AQUI COM SEU CODIGO */
	return (A.n==A.m);
	/* COMPLETE AQUI COM SEU CODIGO */
}

// checa se uma matriz é esparsa
int MatrizEsparsa(Matriz A) {
	/* COMPLETE AQUI COM SEU CODIGO */
	int count=0;
	for (int i=0; i<A.m; i++) {
		for (int j=0; j<A.n; j++) {
			if (A.mat[i][j] == 0) count++;
		}
	}
	return (count > (A.n*A.m)/2);
	/* COMPLETE AQUI COM SEU CODIGO */
}
